; 
    include \masm32\include\masm32rt.inc
; 

    .686p

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL arr   :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL tcnt  :DWORD
    LOCAL sort1 :DWORD
    LOCAL sort2 :DWORD

    mov sort1, 0
    mov sort2, 0

    fn SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

  REPEAT 8

  ; =====================================================================

    mov hMem, InputFile("rand.txt")     ; load the random word file
    mov flen, ecx

    mov tcnt, rv(wtok,hMem,ADDR arr)    ; tokenise it

    cpuid
    invoke SleepEx,200,0                ; pause for 200 ms

    invoke GetTickCount                 ; get first clock count
    push eax

  ; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
    fn assort,arr,tcnt,0                ; sort the string array
  ; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

    invoke GetTickCount                 ; get second clock count
    pop ecx
    sub eax, ecx                        ; calculate ms duration
    push eax

    add sort1, eax

    print "assort timing = "
    pop eax
    print str$(eax)," ms",13,10         ; display results

    free arr                            ; release memory from tokeniser
    free hMem                           ; release file memory

  ; =====================================================================

    mov hMem, InputFile("rand.txt")     ; load the random word file
    mov flen, ecx

    mov tcnt, rv(wtok,hMem,ADDR arr)    ; tokenise it

    cpuid
    invoke SleepEx,200,0                ; pause for 200 ms

    invoke GetTickCount                 ; get first clock count
    push eax

  ; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

    PUSH DWORD PTR 0
    push DWORD PTR 1
    push tcnt
    push arr
    call MergeSort25

  ; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

    invoke GetTickCount                 ; get second clock count
    pop ecx
    sub eax, ecx                        ; calculate ms duration
    push eax

    add sort2, eax

    print "MergeSort25 timing = "
    pop eax
    print str$(eax)," ms",13,10         ; display results

    free arr                            ; release memory from tokeniser
    free hMem                           ; release file memory

  ; =====================================================================

  ENDM

    shr sort1, 3
    print chr$(13,10),"Average lib assort  = "
    print str$(sort1),13,10

    shr sort2, 3
    print "Average MergeSort25 = "
    print str$(sort2),13,10

    fn SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    ret

main endp

; 

    include MergeSort25.asm

end start
